//+---------------------------------------------------------------------+
//|                                                     FX_FISH_2MA.mq5 |
//|                                        Copyright  2005, Kiko Segui | 
//|                                                  webtecnic@terra.es | 
//+---------------------------------------------------------------------+ 
//|     SmoothAlgorithms.mqh      |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2005, Kiko Segui"
#property link "webtecnic@terra.es" 
//---   
#property version   "1.00"
//---     
#property indicator_separate_window 
//---    5
#property indicator_buffers 5 
//---    
#property indicator_plots   4
//+-----------------------------------+
//|     1 |
//+-----------------------------------+
//---      
#property indicator_type1 DRAW_COLOR_HISTOGRAM
//---      
#property indicator_color1 clrMagenta,clrPurple,clrGray,clrBlue,clrDodgerBlue
//---   - 
#property indicator_style1 STYLE_SOLID
//---     2
#property indicator_width1 2
//---   
#property indicator_label1 "FX_FISH Histogram"
//+-----------------------------------+
//|     2 |
//+-----------------------------------+
//---      
#property indicator_type2 DRAW_LINE
//---     
#property indicator_color2 clrDarkViolet
//---   - 
#property indicator_style2 STYLE_SOLID
//---     2
#property indicator_width2 2
//---    
#property indicator_label2  "FX_FISH Line"
//+-----------------------------------+
//|     3 |
//+-----------------------------------+
//---      
#property indicator_type3 DRAW_LINE
//---     
#property indicator_color3 clrTeal
//---   - 
#property indicator_style3 STYLE_SOLID
//---     3
#property indicator_width3 2
//---    
#property indicator_label3  "FX_FISH MA Line1"
//+-----------------------------------+
//|     4 |
//+-----------------------------------+
//---      
#property indicator_type4 DRAW_LINE
//---     
#property indicator_color4 clrDarkOrange
//---   - 
#property indicator_style4 STYLE_SOLID
//---     2
#property indicator_width4 2
//---    
#property indicator_label4  "FX_FISH MA Line2"
//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//---    CXMA   SmoothAlgorithms.mqh
CXMA XMA1,XMA2;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPL_,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  // TrendFollow_2 Price 
   PRICE_DEMARK_         // Demark Price 
  };
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint period=10;                            //   
input Smooth_Method MA_Method1=MODE_SMA;         //   
input uint Length1=9;                            //    
input int Phase1=100;                            //   
//--- Phase1:  JJMA    -100 ... +100,     ;
//--- Phase1:  VIDYA   CMO,  AMA    
input Smooth_Method MA_Method2=MODE_SMA;         //    
input uint Length2 = 45;                         //    
input int Phase2 = 100;                          //    
//--- Phase2:  JJMA    -100 ... +100,     ;
//--- Phase2:  VIDIA   CMO,  AMA    
input Applied_price_ AppliedPrice=PRICE_CLOSE_;  //  
//+-----------------------------------+
//---      
int min_rates_total,min_rates_1,min_rates_2;
//---   ,   
//---      
double IndBuffer1[],IndBuffer2[],IndBuffer3[],IndBuffer4[],IndBuffer[],ColorIndBuffer1[];
//+------------------------------------------------------------------+    
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//---     
   min_rates_1=int(period);
   min_rates_2=min_rates_1+XMA1.GetStartBars(MA_Method1,Length1,Phase1);
   min_rates_total=min_rates_2+XMA1.GetStartBars(MA_Method2,Length2,Phase2);
//---      
   SetIndexBuffer(0,IndBuffer1,INDICATOR_DATA);
   SetIndexBuffer(1,ColorIndBuffer1,INDICATOR_COLOR_INDEX);
   SetIndexBuffer(2,IndBuffer2,INDICATOR_DATA);
   SetIndexBuffer(3,IndBuffer3,INDICATOR_DATA);
   SetIndexBuffer(4,IndBuffer4,INDICATOR_DATA);
//---       
   ArraySetAsSeries(IndBuffer1,true);
   ArraySetAsSeries(ColorIndBuffer1,true);
   ArraySetAsSeries(IndBuffer2,true);
   ArraySetAsSeries(IndBuffer3,true);
   ArraySetAsSeries(IndBuffer4,true);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       
   XMA1.XMALengthCheck("Length1",Length1);
   XMA1.XMALengthCheck("Length2",Length2);
//---       
   XMA1.XMAPhaseCheck("Phase1",Phase1,MA_Method1);
   XMA1.XMAPhaseCheck("Phase2",Phase2,MA_Method2);
//---      
   string shortname;
   StringConcatenate(shortname,"FX_FISH_2MA( ",period,", ",Length1,", ",Length2," )");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//---  
  }
//+------------------------------------------------------------------+  
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---   
   int limit,bar,maxbar1,maxbar2;
//---       
   double price,Value,Range,Fish,MaxH,MinL;
   static double Value1,Fish1;
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_1-1; //      
      Value1=0.0;
      Fish1=0.0;
     }
   else limit=rates_total-prev_calculated;  //       
//---
   maxbar1=rates_total-min_rates_1-1;
   maxbar2=rates_total-min_rates_2-1;
//---         
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(close,true);
//---   
   Value=Value1;
   Fish=Fish1;
//---    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      MaxH=high[ArrayMaximum(high,bar,period)];
      MinL=low[ArrayMinimum(low,bar,period)];
      price=PriceSeries(AppliedPrice,bar,open,low,high,close);
      Range=MaxH-MinL;
      if(Range) Value=0.33*2*((price-MinL)/Range-0.5)+0.67*Value1;
      else Value=0.0;
      Value=MathMin(MathMax(Value,-0.999),0.999);
      Fish=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
      IndBuffer1[bar]=Fish;
      IndBuffer2[bar]=Fish;
      //---   
      if(bar)
        {
         Value1=Value;
         Fish1=Fish;
        }
      IndBuffer3[bar]=XMA1.XMASeries(maxbar1,prev_calculated,rates_total,MA_Method1,Phase1,Length1,Fish,bar,true);
      IndBuffer4[bar]=XMA2.XMASeries(maxbar2,prev_calculated,rates_total,MA_Method2,Phase2,Length2,IndBuffer3[bar],bar,true);
     }
//---
   if(prev_calculated>rates_total || prev_calculated<=0) limit=rates_total-min_rates_total;
//---    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      int clr=2;
      if(IndBuffer1[bar]>0)
        {
         if(IndBuffer1[bar]>IndBuffer1[bar+1]) clr=4;
         if(IndBuffer1[bar]<IndBuffer1[bar+1]) clr=3;
        }
      if(IndBuffer1[bar]<0)
        {
         if(IndBuffer1[bar]<IndBuffer1[bar+1]) clr=0;
         if(IndBuffer1[bar]>IndBuffer1[bar+1]) clr=1;
        }
      ColorIndBuffer1[bar]=clr;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
